
{*******************************************************}
{                                                       }
{       NativeDB Bonus components                       }
{       Dataset for Woll2Woll Infopower components      }
{                                                       }
{       Copyright (c) 1995-2001 Liodden Data            }
{                                                       }
{*******************************************************}

unit Ndbw2w;

interface

uses Classes, wwTypes, NdbAsaDS;

type
  TwwAsaDataSet = class(TAsaDataSet)
  private
    FControlType: TStrings;
    FPictureMasks: TStrings;
    FUsePictureMask: boolean;
    FOnInvalidValue: TwwInvalidValueEvent;
    function GetControlType: TStrings;
    procedure SetControlType(Sel: TStrings);
    function GetPictureMasks: TStrings;
    procedure SetPictureMasks(Sel: TStrings);
  protected
    procedure DoBeforePost; override;
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  published
    property ControlType: TStrings read GetControlType write SetControltype;
    property PictureMasks: TStrings read GetPictureMasks write SetPictureMasks;
    property ValidateWithMask: boolean read FUsePictureMask write FUsePictureMask;
    property OnInvalidValue: TwwInvalidValueEvent read FOnInvalidValue write FOnInvalidValue;
  end;

procedure Register;

implementation

uses wwcommon;

constructor TwwAsaDataSet.create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FControlType := TStringList.create;
  FPictureMasks := TStringList.create;
  FUsePictureMask := True;
end;

destructor TwwAsaDataSet.Destroy;
begin
  FControlType.Free;
  FPictureMasks.Free;
  FPictureMasks := nil;
  inherited Destroy;
end;

function TwwAsaDataSet.GetControltype: TStrings;
begin
  Result := FControlType;
end;

procedure TwwAsaDataSet.SetControlType(Sel: TStrings);
begin
  FControlType.Assign(Sel);
end;

function TwwAsaDataSet.GetPictureMasks: TStrings;
begin
  Result := FPictureMasks;
end;

procedure TwwAsaDataSet.SetPictureMasks(Sel: TStrings);
begin
  FPictureMasks.Assign(Sel);
end;

procedure TwwAsaDataSet.DoBeforePost;
begin
  inherited DoBeforePost;
  if FUsePictureMask then
    wwValidatePictureFields(Self, FOnInvalidValue);
end;

procedure Register;
begin
  RegisterComponents('NativeDB', [TwwAsaDataSet] );
end;

end.

